      .386
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

;**********************************************************************
;     include files
;**********************************************************************     
      include \Altra32\INCLUDE\windows.inc
      include \Altra32\INCLUDE\user32.inc
      include \Altra32\INCLUDE\kernel32.inc
      include \Altra32\INCLUDE\comdlg32.inc
      include \Altra32\include\Comctl32.inc

;**********************************************************************
;     libraries
;**********************************************************************
      includelib \Altra32\LIB\user32.lib
      includelib \Altra32\LIB\kernel32.lib
      includelib \Altra32\LIB\comdlg32.lib
      includelib \Altra32\lib\Comctl32.lib

;**********************************************************************
; Local prototypes
;**********************************************************************
        WinMain                 PROTO :DWORD
        Win1Main                PROTO :DWORD
        Win2Main                PROTO :DWORD
        Win3Main                PROTO :DWORD

        WinProc                 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        Win1Proc                PROTO :DWORD,:DWORD,:DWORD,:DWORD
        Win2Proc                PROTO :DWORD,:DWORD,:DWORD,:DWORD
        Win3Proc                PROTO :DWORD,:DWORD,:DWORD,:DWORD

        wsprintfA               PROTO C :DWORD,:VARARG

        wsprintf equ <wsprintfA>

;**********************************************************************
; Local macros
;**********************************************************************
include \altra32\macros\macros.asm

;**********************************************************************
; Place all your Constance here.
;**********************************************************************
.const
ICO_MAINICON     equ 500

;**********************************************************************
; Inishilized DATA
;**********************************************************************
.data
Wwidth           dd 350
Wheight          dd 315
szClassName      db "Template_Class",0
szClassName1     db "Template1_Class",0
szClassName2     db "Template2_Class",0
szClassName3     db "Template3_Class",0
szAppName        db "Window 1",0
szAppName1       db "Window 2",0
szAppName2       db "Window 3",0
szAppName3       db "Window 4",0
;**********************************************************************
; Un-Inishilized DATA
;**********************************************************************
.data?
hWnd             dd ?
hWnd1            dd ?
hWnd2            dd ?
hWnd3            dd ?
hInstance        dd ?
hIcon            dd ?
hIcon1           dd ?
hIcon2           dd ?
hIcon3           dd ?

.code
;**********************************************************************
; This is the start of the code section, here we get our Module Handle
; and start our Program.
;**********************************************************************
start:
      mov hInstance,FUNC(GetModuleHandle,NULL)
      invoke WinMain,hInstance 
      invoke ExitProcess,eax

;**********************************************************************
; This section creates the MAIN CLASS and the MAIN window.
; Then loops sending messages to our WinProc for Proccessing.
;**********************************************************************
WinMain proc hModule:DWORD

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG

      mov hIcon,FUNC(LoadIcon,hModule,ICO_MAINICON)    ; icon ID
      mov wc.cbSize,sizeof WNDCLASSEX
      mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,offset WinProc
      mov wc.cbClsExtra,NULL
      mov wc.cbWndExtra,NULL
      m2m wc.hInstance,hModule
      mov wc.hbrBackground,COLOR_BTNFACE+1
      mov wc.lpszMenuName,NULL
      mov wc.lpszClassName,offset szClassName
      m2m wc.hIcon,hIcon
      mov wc.hCursor,FUNC(LoadCursor,NULL,IDC_ARROW)
      m2m wc.hIconSm,hIcon
      invoke RegisterClassEx, addr wc
      mov hWnd,FUNC(CreateWindowEx,WS_EX_LEFT,addr szClassName,addr szAppName,WS_SIZEBOX or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_POPUP or WS_VISIBLE or WS_BORDER or WS_DLGFRAME,10,10,Wwidth,Wheight,NULL,NULL,hModule,NULL)
      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd
      MSGLOOP msg
WinMain endp
;**********************************************************************
; This is the Main programs code area. all messages for this APP are
; recived here, or the main app.
;**********************************************************************
WinProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD


          .if uMsg == WM_CREATE
              invoke Win1Main,hInstance 
              invoke Win2Main,hInstance
              invoke Win3Main,hInstance

          .elseif uMsg == WM_PAINT


          .elseif uMsg == WM_COMMAND


          .elseif uMsg == WM_SIZE


          .elseif uMsg == WM_CLOSE
                  invoke DestroyIcon,hIcon
                  invoke DestroyWindow,hWin

          .elseif uMsg == WM_DESTROY
                  invoke PostQuitMessage,0
                  return 0
          .endif


          invoke DefWindowProc,hWin,uMsg,wParam,lParam
          ret
WinProc endp
;**********************************************************************
; This section creates the MAIN CLASS and the MAIN window.
; Then loops sending messages to our WinProc for Proccessing.
;**********************************************************************
Win1Main proc hModule:DWORD

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG

      mov hIcon1,FUNC(LoadIcon,hModule,ICO_MAINICON)    ; icon ID
      mov wc.cbSize,sizeof WNDCLASSEX
      mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,offset Win1Proc
      mov wc.cbClsExtra,NULL
      mov wc.cbWndExtra,NULL
      m2m wc.hInstance,hModule
      mov wc.hbrBackground,COLOR_BTNFACE+1
      mov wc.lpszMenuName,NULL
      mov wc.lpszClassName,offset szClassName1
      m2m wc.hIcon,hIcon1
      mov wc.hCursor,FUNC(LoadCursor,NULL,IDC_ARROW)
      m2m wc.hIconSm,hIcon1
      invoke RegisterClassEx, addr wc
      mov hWnd1,FUNC(CreateWindowEx,WS_EX_LEFT,addr szClassName1,addr szAppName1,WS_SIZEBOX or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_POPUP or WS_VISIBLE or WS_BORDER or WS_DLGFRAME,10,10,Wwidth,Wheight,NULL,NULL,hModule,NULL)
      invoke ShowWindow,hWnd1,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd1
      ret
Win1Main endp
;**********************************************************************
; This is the Main programs code area. all messages for this APP are
; recived here, or the main app.
;**********************************************************************
Win1Proc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD


          .if uMsg == WM_CREATE


          .elseif uMsg == WM_PAINT


          .elseif uMsg == WM_COMMAND


          .elseif uMsg == WM_SIZE


          .elseif uMsg == WM_CLOSE
                  invoke DestroyIcon,hIcon1
                  invoke DestroyWindow,hWin

          .elseif uMsg == WM_DESTROY
                  invoke PostQuitMessage,0
                  return 0
          .endif


          invoke DefWindowProc,hWin,uMsg,wParam,lParam
          ret
Win1Proc endp
;**********************************************************************
; This section creates the MAIN CLASS and the MAIN window.
; Then loops sending messages to our WinProc for Proccessing.
;**********************************************************************
Win2Main proc hModule:DWORD

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG

      mov hIcon2,FUNC(LoadIcon,hModule,ICO_MAINICON)    ; icon ID
      mov wc.cbSize,sizeof WNDCLASSEX
      mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,offset Win2Proc
      mov wc.cbClsExtra,NULL
      mov wc.cbWndExtra,NULL
      m2m wc.hInstance,hModule
      mov wc.hbrBackground,COLOR_BTNFACE+1
      mov wc.lpszMenuName,NULL
      mov wc.lpszClassName,offset szClassName2
      m2m wc.hIcon,hIcon2
      mov wc.hCursor,FUNC(LoadCursor,NULL,IDC_ARROW)
      m2m wc.hIconSm,hIcon2
      invoke RegisterClassEx, addr wc
      mov hWnd2,FUNC(CreateWindowEx,WS_EX_LEFT,addr szClassName2,addr szAppName2,WS_SIZEBOX or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_POPUP or WS_VISIBLE or WS_BORDER or WS_DLGFRAME,10,10,Wwidth,Wheight,NULL,NULL,hModule,NULL)
      invoke ShowWindow,hWnd2,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd2
      ret
Win2Main endp
;**********************************************************************
; This is the Main programs code area. all messages for this APP are
; recived here, or the main app.
;**********************************************************************
Win2Proc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD


          .if uMsg == WM_CREATE


          .elseif uMsg == WM_PAINT


          .elseif uMsg == WM_COMMAND


          .elseif uMsg == WM_SIZE


          .elseif uMsg == WM_CLOSE
                  invoke DestroyIcon,hIcon2
                  invoke DestroyWindow,hWin

          .elseif uMsg == WM_DESTROY
                  invoke PostQuitMessage,0
                  return 0
          .endif


          invoke DefWindowProc,hWin,uMsg,wParam,lParam
          ret
Win2Proc endp
;**********************************************************************
; This section creates the MAIN CLASS and the MAIN window.
; Then loops sending messages to our WinProc for Proccessing.
;**********************************************************************
Win3Main proc hModule:DWORD

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG

      mov hIcon3,FUNC(LoadIcon,hModule,ICO_MAINICON)    ; icon ID
      mov wc.cbSize,sizeof WNDCLASSEX
      mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,offset Win3Proc
      mov wc.cbClsExtra,NULL
      mov wc.cbWndExtra,NULL
      m2m wc.hInstance,hModule
      mov wc.hbrBackground,COLOR_BTNFACE+1
      mov wc.lpszMenuName,NULL
      mov wc.lpszClassName,offset szClassName3
      m2m wc.hIcon,hIcon3
      mov wc.hCursor,FUNC(LoadCursor,NULL,IDC_ARROW)
      m2m wc.hIconSm,hIcon3
      invoke RegisterClassEx, addr wc
      mov hWnd3,FUNC(CreateWindowEx,WS_EX_LEFT,addr szClassName3,addr szAppName3,WS_SIZEBOX or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_POPUP or WS_VISIBLE or WS_BORDER or WS_DLGFRAME,10,10,Wwidth,Wheight,NULL,NULL,hModule,NULL)
      invoke ShowWindow,hWnd3,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd3
      ret
Win3Main endp
;**********************************************************************
; This is the Main programs code area. all messages for this APP are
; recived here, or the main app.
;**********************************************************************
Win3Proc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD


          .if uMsg == WM_CREATE


          .elseif uMsg == WM_PAINT


          .elseif uMsg == WM_COMMAND


          .elseif uMsg == WM_SIZE


          .elseif uMsg == WM_CLOSE
                  invoke DestroyIcon,hIcon3
                  invoke DestroyWindow,hWin

          .elseif uMsg == WM_DESTROY
                  invoke PostQuitMessage,0
                  return 0
          .endif


          invoke DefWindowProc,hWin,uMsg,wParam,lParam
          ret
Win3Proc endp

end start
